import 'package:flutter/material.dart';
import 'package:kubernetes/core_v1.dart';
import 'package:yakc/views/object_meta_widget.dart';

class ServiceViewPage extends StatefulWidget {
  const ServiceViewPage({
    required this.service,
    Key? key,
  }) : super(key: key);

  final Service service;

  @override
  State<ServiceViewPage> createState() => _ServiceViewPageState();
}

class _ServiceViewPageState extends State<ServiceViewPage> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text('Service'),
      ),
      body: ListView(
        padding: const EdgeInsets.all(4.0),
        children: [
          Padding(
            padding: const EdgeInsets.all(4.0),
            child: Card(
              child: ObjectMetaWidget(metadata: widget.service.metadata!),
            ),
          ),
          if (widget.service.spec != null)
            Padding(
              padding: const EdgeInsets.all(4.0),
              child: Card(
                child: Column(
                  children: widget.service.spec!.ports!
                      .map(
                        (e) => ListTile(
                          title: Text(e.name ?? ''),
                          subtitle: Text(e.port.toString()),
                        ),
                      )
                      .toList(),
                ),
              ),
            ),
        ],
      ),
    );
  }
}
